// TNAFlix.js for PSPTube
// Made By JK108

function TNAFlix_CheckURL( url, option )
{
	if (url.match("http://www.tnaflix.com/view_video.php") == "http://www.tnaflix.com/view_video.php"){
		return 1;
	} else{
		return 0;
	}
}

/*
 Get a TNAFlix URL
*/
function TNAFlix_GetURL( url, option )
{
	var contents = GetContents( url );
	if(contents == null) { return null; /* error getting page */ }
	var pos = contents.indexOf("so.addVariable('videoUrl','");
	contents = contents.substring(pos + 27, contents.length);
	pos = contents.indexOf("');");
	var video_url = contents.substring(0, pos).replace("%3", "?");
	return video_url;
}

function TNAFlix_Search( keyword, start_index, length, option )
{
	var result = new Object();
        result.keyword   = keyword;	// Search
	result.VideoInfo = new Array();	// Results in sequence
	result.start     = start_index;	// Index of first result
	result.end       = 0;
	result.total     = -1;
	var perpage = 32;


	if(keyword.toLowerCase().substring(0, 8) == "!current" || keyword.toLowerCase().substring(0, 7) == "!recent" ||
	   keyword.toLowerCase().substring(0, 7) == "!viewed" || keyword.toLowerCase().substring(0, 6) == "!rated" ||
	   keyword.toLowerCase().substring(0, 6) == "!15min"){
		perpage = 20;
	}


	result.start = (((result.start - 1) / 10) * perpage) + 1;
	var num = 1 + ((result.start - 1) / perpage);


	if(keyword.toLowerCase().substring(0, 8) == "!current"){
		var contents = GetContents( "http://www.tnaflix.com/video.php?category=bw&page=" + num );
	} else if(keyword.toLowerCase().substring(0, 7) == "!recent"){
		var contents = GetContents( "http://www.tnaflix.com/video.php?category=mr&page=" + num );
	} else if(keyword.toLowerCase().substring(0, 7) == "!viewed"){
		var contents = GetContents( "http://www.tnaflix.com/video.php?category=mv&page=" + num );
	} else if(keyword.toLowerCase().substring(0, 6) == "!rated"){
		var contents = GetContents( "http://www.tnaflix.com/video.php?category=tr&page=" + num );
	} else if(keyword.toLowerCase().substring(0, 6) == "!15min"){
		var contents = GetContents( "http://www.tnaflix.com/video.php?category=rd&page=" + num );
	} else{
		if(result.start < 32){
			var contents = GetContents( "http://www.tnaflix.com/search.php?what=" + keyword.replace(/ /g, "%20") );
		} else{
			var contents = GetContents( "http://www.tnaflix.com/search.php?page=" + num + "&what=" + keyword.replace(/ /g, "%20") );
		}
	}
	if(contents == null) { return null; /* failed to get page */ }



	var pos = contents.indexOf('<img src="http://www.tnaflix.com/images/video_icon.gif" alt="');
	contents = contents.substring(pos + 61, contents.length);
	pos = contents.indexOf(" Videos");
	var total = contents.substring(0, pos);
	result.total = total;



	while(1){
	pos = contents.indexOf("<div class=\"videoThumbContainer\">");

	if(pos != -1){
		//Get URL
		contents = contents.substring(pos + 33, contents.length);
		var url = contents.match(/\<a href\=\"(.*?)\"/);
		var url = url[1];
		//Get Title
		var title = contents.match(/title\=\"(.*?)\"/);
		var title = ImproveText(title[1]);
		//Thumbnail
		var thumb_url = contents.match(/\<img src\=\"(.*?)\"/);
		var thumb_url = thumb_url[1];
		//Length
		var length = contents.match(/\<div class\=\"videoLeft\"\>(.*?)\<br/);
		var length = TimestringToSeconds(length[1]);
		//Description
		var description = contents.match(/\<div class\=\"videoSnippet\"\>(.*?)\<\/div\>/);
		var description = splitTo2Lines(ImproveText(description[1]), 60);

		info = new Object();
		info.URL = url;
		info.Title = title;
		info.ThumbnailURL = thumb_url;
		info.LengthSeconds = length;
		info.Description = description;
		info.SaveFilename = ToFilename(title);
		info.attr = 7;
		result.VideoInfo.push( info );
		if(result.VideoInfo.length == perpage){break;}
		if(result.start + (result.VideoInfo.length - 1) == result.total){break;}
	} else{
		break;
	}
	}


	if(result.VideoInfo.length) {
		result.end   = result.start + (result.VideoInfo.length - 1);
	} else {
		result.total = 0;	// no results.
	}

	if(result.VideoInfo.length != perpage){result.total = result.end;}

	return result;
}

// Service metadata
var TNAFlix = new Object();
TNAFlix.Name          = "TNAFlix";		/* Service name */
TNAFlix.Description   = "TNAFlix";		/* Service description */
TNAFlix.SearchDesc    = "TNAFlix";		/* Service search screen description */
TNAFlix.SearchOSKMode = 1;			/* OSK mode 1: English only  2: Japanese */
TNAFlix.CheckURL      = TNAFlix_CheckURL;	/* CheckURL function */
TNAFlix.GetURL        = TNAFlix_GetURL;		/* GetURL function */
TNAFlix.Search        = TNAFlix_Search;		/* Search function */

// add YouTube to site list
SiteList.push( TNAFlix );
