// Yuvutu.js for PSPTube
// Made By JK108

function Yuvutu_CheckURL( url, option )
{
	if (url.match("http://freeserver111.net63.net/yuvutu.php") == "http://freeserver111.net63.net/yuvutu.php"){
		return 1;
	} else{
		return 0;
	}
}

/*
 Get a Yuvutu URL
*/
function Yuvutu_GetURL( url, option )
{
	var contents = GetContents(url);
	if(contents == null) { return null; /* failed to get page */ }
	var video_url = contents.match(/\<video\>(.*?)\<\/video\>/);
	var video_url = video_url[1];
	return video_url;
}

function Yuvutu_Search( keyword, start_index, length, option )
{
	var result = new Object();
        result.keyword   = keyword;	// Search
	result.VideoInfo = new Array();	// Results in sequence
	result.start     = start_index;	// Index of first result
	result.end       = 0;
	result.total     = -1;
	var perpage = 28;


	result.start = (((result.start - 1) / 10) * perpage) + 1;


	if(result.start < perpage){
	var contents = GetContents( "http://freeserver111.net63.net/yuvutu.php?q=" + keyword.replace(/ /g, "%20") + "&p=1" );
	} else{
	var num = 1 + ((result.start - 1) / perpage);
	var contents = GetContents( "http://freeserver111.net63.net/yuvutu.php?q=" + keyword.replace(/ /g, "%20") + "&p=" + num );
	}
	if(contents == null) { return null; /* failed to get page */ }


	result.total = 10000;


	while(1){
	var pos = contents.indexOf("<item>");

	if(pos != -1){
		contents = contents.substring(pos + 6, contents.length);
		//Get URL
		var url = contents.match(/\<url\>(.*?)\<\/url\>/);
		var url = url[1];
		//Get Thumbnail
		var thumb_url = contents.match(/\<thumbnail\>(.*?)\<\/thumbnail\>/);
		var thumb_url = thumb_url[1];
		//Title
		var title = contents.match(/\<title\>(.*?)\<\/title\>/);
		var title = ImproveText(title[1]);
		//Length
		var length = contents.match(/\<duration\>(.*?)\<\/duration\>/);
		var length = parseInt(length[1]);
		//Description
		var description = splitTo2Lines(title, 60);
		
		info = new Object();
		info.URL = url;
		info.ThumbnailURL = thumb_url;
		info.Title = title;
		info.LengthSeconds = length;
		info.Description = description;
		info.SaveFilename = ToFilename(title);
		info.attr = 7;
		result.VideoInfo.push( info );
		if(result.VideoInfo.length == perpage){break;}
		if(result.start + (result.VideoInfo.length - 1) == result.total){break;}
	} else{
		break;
	}
	}


	if(result.VideoInfo.length) {
		result.end = result.start + (result.VideoInfo.length - 1);
	} else {
		result.total = 0;	// no results.
	}

	if(result.VideoInfo.length != perpage){result.total = result.end;}

	return result;
}

// Service metadata
var Yuvutu = new Object();
Yuvutu.Name          = "Yuvutu";		/* Service name */
Yuvutu.Description   = "Yuvutu";		/* Service description */
Yuvutu.SearchDesc    = "Yuvutu";		/* Service search screen description */
Yuvutu.SearchOSKMode = 1;			/* OSK mode 1: English only  2: Japanese */
Yuvutu.CheckURL      = Yuvutu_CheckURL;		/* CheckURL function */
Yuvutu.GetURL        = Yuvutu_GetURL;		/* GetURL function */
Yuvutu.Search        = Yuvutu_Search;		/* Search function */

// add Yuvutu to site list
SiteList.push( Yuvutu );
